﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace RefreshUnboundFields
{
    public partial class Form1 : Form
    {
        Hashtable UnboundValues = new Hashtable();
        int topRowOffset;
        double defaultvalue=48.14;
        
        public Form1()
        {
            InitializeComponent();

            topRowOffset = 0;
            BindingList<CustomClass> bl = new BindingList<CustomClass>();
            bl.Add(new CustomClass(0101, "Charlotte", "Cooper", "49 Gilbert St.", "London"));
            bl.Add(new CustomClass(0102, "Shelley", "Burke", "P.O. Box 78934", "New Orleans"));
            bl.Add(new CustomClass(0103, "Regina", "Murphy", "707 Oxford Rd.", "Ann Arbor"));
            bl.Add(new CustomClass(0104, "Yoshi", "Nagase", "9-8 Sekimai Musashino-shi", "Tokyo"));
            bl.Add(new CustomClass(0105, "Mayumi", "Ohno", "Calle del Rosal 4", "Oviedo"));

            this.gridGroupingControl1.DataSource = bl;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupingControl1.AllowDrop = false;
            topRowOffset = 0;
            //adding unbound column and setting type.
            this.gridGroupingControl1.TableDescriptor.UnboundFields.Add("UnboundField");
  
            this.gridGroupingControl1.TableDescriptor.UnboundFields["UnboundField"].ReferencedFields = "City";

            this.gridGroupingControl1.TableDescriptor.Columns["UnboundField"].Appearance.AnyCell.CellValueType = typeof(double);
            this.gridGroupingControl1.TableDescriptor.Columns["UnboundField"].Appearance.AnyCell.Format = "00.00";

            this.gridGroupingControl1.SourceListListChanged += gridGroupingControl1_SourceListListChanged;
            
            topRowOffset = this.gridGroupingControl1.TableControl.TopRowIndex;
            //Set Hashtable vaule
            for (int i = 0; i < this.gridGroupingControl1.Table.FilteredRecords.Count; i++)
            {
                UnboundValues.Add(this.gridGroupingControl1.Table.FilteredRecords[i].Id, i + 20);
            }
            //Error provider Properties
            this.gridGroupingControl1.TableControl.ShowRowHeaderErroricon = false;
            this.gridGroupingControl1.TableControl.CurrentCell.ShowErrorIcon = false;
            this.gridGroupingControl1.TableControl.CurrentCell.ShowErrorMessageBox = false;
            this.gridGroupingControl1.TableControl.CurrentCell.ValidationErrorText = string.Empty;
            //events for saving the Unboundvalues entered.
           // this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(unboundField_QueryValue);
            this.gridGroupingControl1.TableControlCurrentCellKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlCurrentCellKeyDown);
            
        }

        void gridGroupingControl1_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            double temp = 0;
            if (e.Inner.KeyCode == Keys.Enter && !(double.TryParse(this.gridGroupingControl1.TableModel.CurrentCellRenderer.ControlText.ToString(),out temp)))
            {
                this.gridGroupingControl1.TableModel.CurrentCellRenderer.ControlText = defaultvalue.ToString();
                this.gridGroupingControl1.Refresh();
            }

        }
       
     
        void gridGroupingControl1_SourceListListChanged(object sender, TableListChangedEventArgs e)
        {
            if (e.ListChangedType == ListChangedType.ItemChanged)
            {
                if (e.Table.CurrentRecordManager.CurrentField.Name == "UnboundField" && e.Table.CurrentRecordManager.Properties["UnboundField"].IsModified)
                {
                    UnboundValues[e.Table.CurrentRecord.Id] = e.Table.CurrentRecordManager.Properties["UnboundField"].ModifiedValue;
                    e.Table.CurrentRecordManager.EndEdit();
                }
                this.gridGroupingControl1.TableControl.RefreshRange(GridRangeInfo.Row(e.NewIndex + topRowOffset));
            }
        }

        
        #region events
        //Getting the checkBox values in a hashtable.
        private void unboundField_QueryValue(object sender, FieldValueEventArgs e)
        {
            int RecordIndex = this.gridGroupingControl1.Table.PrimaryKeySortedRecords.IndexOf(e.Record);
            if (e.Field.Name == "UnboundField" && e.Record.Id >= 0)
            {
                e.Value = UnboundValues[e.Record.Id];
            }
        }
        #endregion
    }


    public class CustomClass : INotifyPropertyChanged
    {
        int id;
        string first_name;
        string last_name;
        string address;
        string city;

        public CustomClass(int id, string fname, string lname, string addr, string city)
        {
            this.id = id;
            first_name = fname;
            last_name = lname;
            address = addr;
            this.city = city;
        }

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    RaisePropertyChanged("ID");
                }
            }
        }

        public string FirstName
        {
            get { return first_name; }
            set
            {
                if (first_name != value)
                {
                    first_name = value;
                    RaisePropertyChanged("FirstName");
                }
            }
        }

        public string LastName
        {
            get { return last_name; }
            set
            {
                if (last_name != value)
                {
                    last_name = value;
                    RaisePropertyChanged("LastName");
                }
                last_name = value;
            }
        }

        public string Address
        {
            get { return address; }
            set
            {
                if (address != value)
                {
                    address = value;
                    RaisePropertyChanged("Address");
                }
            }
        }

        public string City
        {
            get { return city; }
            set
            {
                if (city != value)
                {
                    city = value;
                    RaisePropertyChanged("City");
                }
            }
        }

        void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)          
                PropertyChanged(this, new PropertyChangedEventArgs(name));            
        }

        //INotifyPropertyChanged Members.
        public event PropertyChangedEventHandler PropertyChanged;

    }
}
